<?php
	
	if( !class_exists('In8_Queue') ) return;
	
	class In8_Queue_Subscriptions extends In8_Queue {
		
		public $id = "subscriptions";
		
		public function _getEntities() {
			
			global $wpdb;
			$interval = date( 'Y-m-d h:i:s', time() - 3600 * 24 * 7 );
			$interval = apply_filters( 'in8_queue_subscriptions_interval', $interval );
			
			$query  = "SELECT * FROM {$wpdb->posts}
						LEFT JOIN (SELECT meta_value, post_id FROM {$wpdb->postmeta} WHERE meta_key='auto_delivery_order') as subscription_order ON subscription_order.post_id={$wpdb->posts}.ID
						LEFT JOIN (SELECT meta_value as subscription_id, post_id FROM {$wpdb->postmeta} WHERE meta_key LIKE 'subscription_id_%') as subscription_order_id  ON subscription_order_id .post_id={$wpdb->posts}.ID
						 WHERE post_type='shop_order' AND post_date>'{$interval}' AND subscription_order.meta_value=1 AND (subscription_order_id.subscription_id='' OR subscription_order_id.subscription_id IS NULL)";
			$orders = $wpdb->get_results( $query );
			
			$subscriptions = [];
			
			foreach ( $orders as $postOrder ) {
				$order = wc_get_order( $postOrder->ID );
				foreach ( $order->get_items() as $item ) {
					$recurrence = $item->get_meta( 'is_subscription_item' );
					if ( empty( $recurrence ) ) {
						continue;
					}
					$subscriptions[] = [
						'order_id'   => $postOrder->ID,
						'recurrence' => $recurrence,
					];
				}
			}
			
			echo "<pre>";print_r($subscriptions);echo "</pre>";
			
			return $subscriptions;
		}
		
		public function shouldProcess( $entity ) {
			$entity_id = get_post_meta( $entity['order_id'], 'subscription_id_' . $entity['recurrence'], TRUE );
			if ( ! empty( $entity_id ) ) {
				return FALSE;
			}
			
			$test_key = 'in8_failed_syncing_subscription';
			$tester   = new In8_Sync_Tester( $entity['order_id'], $test_key );
			if ( (integer) $tester->val() >= 4 || $tester->val() === 'Failed 3 times, has to be reviewed.' ) {
				// make the value more readable
				if ( (integer) $tester->val() >= 4 ) {
					$tester->set( 'Failed 3 times, has to be reviewed.' );
					
					return FALSE;
				}
			}
			
			return TRUE;
		}
		
		public function processEntity( $entity ) {
			do_action('in8sync_async_sendOrderToNetsuite', $entity['order_id'], 0, FALSE, TRUE);
			do_action('in8sync_async_syncOnNetsuite', $entity['order_id'], FALSE, TRUE);
			
			$tester = new In8_Sync_Tester( $entity['order_id'], 'in8_failed_syncing_subscription' );
			$tester->increment();
			wp_mail('daniel@in8sync.com', 'Subscription Queue testing', json_encode($entity));
		}
		
	}
	
	$options = In8_SalesOrder::getOptions( 2 );
	if( isset($options['enable_subscription_queue']) && $options['enable_subscription_queue'] == 'on' ) {
		$In8_Queue_Subscriptions = new In8_Queue_Subscriptions();
	}
	
